`FormatDF` <-
function(inputDF, digits, row.names = TRUE)  {
  if(!is.data.frame(inputDF))
    stop("'inputDF' must be a data frame\n")

  nr <- nrow(inputDF)
  nc <- ncol(inputDF)

  output.body <- character(nr)
  for(i in 1:nc)  {
    temp <- inputDF[[i]]
    if(is.factor(temp))
      temp <- as.character(temp)

    if(!is.character(temp))  {
      temp <- formatC(temp, digits = digits[i], format = "f")
      output.body <- paste(output.body,
                           paste("<TD align=\"center\">", temp, "</TD>"),
                           sep = "")
    }else  {
      output.body <- paste(output.body,
                           paste("<TD>", temp, "</TD>"),
                           sep = "")
    }
  }

  if(row.names)  {
    output.rownames <- paste("<TD align=\"center\">", rownames(inputDF), "</TD>")
    output.colnames <-
      paste(paste("<TH>", c("", colnames(inputDF)), "</TH>"), collapse = "")
    output <-
      c("<TABLE border=1 >",
        paste("<TR>",
            c(output.colnames, paste(output.rownames, output.body)),
              "</TR>"),
        "</TABLE>"
       )
  }else  {
    output.colnames <-
      paste(paste("<TH>", colnames(inputDF), "</TH>"), collapse = "")
    output <-
      c("<TABLE border=1  >",
        paste("<TR>",
            c(output.colnames, output.body),
              "</TR>"),
        "</TABLE>"
       )

  }

  return(output)
}

