`calcCBS` <-
function(y, ys = NULL,
                    chrs = rep.int(1, length(y)),
                    spos = 2*(1:length(y)) - 1,
                    epos = 2*(1:length(y)),
                    verbose = 0,
                    ...)  {
  if(is.null(ys))
    ys <- y
  segtable <- DNAcopy::segment(CNA(ys, chrs, 1:length(ys)),
                               verbose = verbose, ...)$output
  yseg <- numeric(length(y))
  for(i in 1:nrow(segtable))  {
    idx <- segtable$loc.start[i]:segtable$loc.end[i]
    yseg[idx] <- mean(y[idx], na.rm = TRUE)
  }

  yseg[is.na(y)] <- NA
  attr(yseg, "dataType") <- "SLR"
  return(yseg)
}

