`calcCoords` <-
function(x, y, opar = par(), res = 100)  {
  left.inner.margin <- opar$mai[2]
  right.inner.margin <- opar$mai[4]
  top.inner.margin <- opar$mai[3]
  bottom.inner.margin <- opar$mai[1]

  left.outer.margin <- opar$omi[2]
  right.outer.margin <- opar$omi[4]
  top.outer.margin <- opar$omi[3]
  bottom.outer.margin <- opar$omi[1]

  figure.width <- opar$fin[1]
  figure.height <- opar$fin[2]

  device.width <- opar$din[1]
  device.height <- opar$din[2]

  xlim <- opar$usr[1:2]
  ylim <- opar$usr[3:4]
  NDC <- opar$fig

  ## max.figure.width and max.figure.height becomes important when NDC is not (0,1,0,1)
  max.figure.width <- device.width - left.outer.margin - right.outer.margin
  max.figure.height <- device.height - top.outer.margin - bottom.outer.margin

  slope.x <- (figure.width - left.inner.margin - right.inner.margin) / (xlim[2] - xlim[1])
  slope.y <- (figure.height - top.inner.margin - bottom.inner.margin) / (ylim[1] - ylim[2])

  intercept.x <- (left.outer.margin + left.inner.margin + (NDC[1] - 0)*max.figure.width)
  intercept.y <- (top.outer.margin + top.inner.margin + (1 - NDC[4])*max.figure.height)

  ## This gives us coordinates in inches
  x.inches <- intercept.x + slope.x*(x - xlim[1])
  y.inches <- intercept.y + slope.y*(y - ylim[2])

  ## Return coordinates in pixels
  return(list(x = round(res*x.inches), y = round(res*y.inches)))
}

