`calcFASeg` <-
function(y, ys = NULL,
                      chrs = rep.int(1, length(y)),
                      spos = 2*(1:length(y)) - 1,
                      epos = 2*(1:length(y)),
                      log.transform = FALSE,
                      fine.tune = FALSE,
                      ...)  {
  if(is.null(ys))
    ys <- y
  yfa <- faseg(data.frame(chrs, spos, ys), log.transform = log.transform,
               fine.tune = fine.tune, ...)[[3]]
  
  ep <- which(diff(yfa) != 0)
  sp <- c(1,ep+1)
  ep <- c(ep, length(yfa))

  yseg <- numeric(length(y))
  for(i in 1:length(sp))  {
    idx <- sp[i]:ep[i]
    yseg[idx] <- mean(y[idx], na.rm = TRUE)
  }

  yseg[is.na(y)] <- NA
  attr(yseg, "dataType") <- "SLR"
  return(yseg)
}

