`calcFL` <-
function(y, ys = NULL,
                   chrs = rep.int(1, length(y)),
                   spos = 2*(1:length(y)) - 1,
                   epos = 2*(1:length(y)),
                   recalcSegmentMeans = FALSE,
                   ...)  {
  if(is.null(ys))
    ys <- y

  yfl <- cghFLasso(ys, chrs, ...)[[1]]

  if(recalcSegmentMeans)  {
    ep <- which(diff(yfl) != 0)
    sp <- c(1,ep+1)
    ep <- c(ep, length(yfl))

    yseg <- numeric(length(y))
    for(i in 1:length(sp))  {
      idx <- sp[i]:ep[i]
      yseg[idx] <- mean(y[idx], na.rm = TRUE)
    }
  }else  {
    yseg <- yfl
  }
  
  yseg[is.na(y)] <- NA
  attr(yseg, "dataType") <- "SLR"  
  return(yseg)
}

