`calcGLAD` <-
function(y, ys = NULL,
                     chrs = rep.int(1, length(y)),
                     spos = 2*(1:length(y)) - 1,
                     epos = 2*(1:length(y)),
                     ...)  {
  if(is.null(ys))
    ys <- y
  pcgh <- data.frame(LogRatio = ys, Chromosome = chrs, PosOrder = 1:length(ys),
                     PosBase = spos)
  pv <- glad(as.profileCGH(pcgh), ...)$profileValues

  yseg <- numeric(length(y))
  for(region in unique(pv$Region))  {
    idx <- pv$PosOrder[pv$Region == region]
    yseg[idx] <- mean(y[idx], na.rm = TRUE)
  }

  yseg[is.na(y)] <- NA
  attr(yseg, "dataType") <- "SLR"
  return(yseg)
}

