`calcPicard` <-
function(y, ys = NULL,
                       chrs = rep.int(1, length(y)),
                       spos = 2*(1:length(y)) - 1,
                       epos = 2*(1:length(y)),
                       verbose = FALSE,  ...)  {

  if(is.null(ys))
    ys <- y
  segtable <- CGHseg(ys, chrs, verbose = verbose, ...)
  yseg <- numeric(length(y))
  for(i in 1:nrow(segtable))  {
    idx <- segtable$StartIdx[i]:segtable$EndIdx[i]
    yseg[idx] <- mean(y[idx], na.rm = TRUE)
  }

  yseg[is.na(y)] <- NA
  attr(yseg, "dataType") <- "SLR"
  return(yseg)
}

