`calcSMFN` <-
function(y, x = NULL, smFcn = NULL,
                     chrs = rep.int(1, length(y)),
                     ...)  {
  flag <- FALSE
  # cat ("in calc SMFM\n")
  if(!is.null(smFcn))  {
      ys <- rep(NA, length(y))
    for(chr in unique(chrs))  {
      idx.chrs <- which(chrs == chr)
      if(is.null(x))  {
        tmp <- smFcn(y = y[idx.chrs], ...)
        ## Check if the smoothing has been successfully performed
        if(!is.null(tmp))
          ys[idx.chrs] <- tmp
        else  {
          flag <- TRUE
          break
        }
      }else  {
        ## This part is written for algorithms (e.g. lowess) that have
        ## the ability to smooth the data while taking the position
        ## into account
        tmp <- smFcn(y = y[idx.chrs], x = x[idx.chrs], ...)
        if(!is.null(tmp))
          ys[idx.chrs] <- tmp
        else  {
          flag <- TRUE
          break
        }
      }
    }

    if(!flag)
      attr(ys, "dataType") <- "SLR"
    else  {
      ys <- rep(NA, length(y))
      attr(ys, "dataType") <- "error"
    }

    return(ys)
  }else  {
    stop("Please specify a smoothing function in the inputs.\n")
  }
}

