`divideChrom` <-
function(chrs, maxsize = 10000)  {
  unique.chrs <- unique(chrs)
  npchrs <- table(chrs)[unique.chrs]

  eidx <- cumsum(npchrs)
  sidx <- c(1, 1+eidx[-length(eidx)])

  chrsOutput <- chrs
  tmpidx <- which(npchrs > maxsize)
  if(length(tmpidx) > 0)  {
    for(i in tmpidx)  {
      ndiv <- ceiling(npchrs[i] / maxsize)
      tmpE <- round(seq(0, npchrs[i], length.out = ndiv + 1)[-1])
      tmpS <- c(1, 1+tmpE[-length(tmpE)])
      tmpsize <- tmpE - tmpS + 1
      tmpchr <- rep(paste(unique.chrs[i], "_", 1:ndiv, sep = ""), times = tmpsize)
      chrsOutput[sidx[i]:eidx[i]] <- tmpchr
    }
  }

  return(chrsOutput)
}

