`divideChromByCM` <-
function(chrs, pos = NULL, maxsize = 10000, cb = NULL, minsize = 10)  {
  if(is.null(cb) | is.null(pos))
    stop("Either cb or pos is NULL")

  unique.chrs <- unique(chrs)

  npchrs <- table(chrs)[unique.chrs]

  eidx <- cumsum(npchrs)
  sidx <- c(1, 1+eidx[-length(eidx)])
  chrsize <- eidx - sidx + 1

  chrsOutput <- chrs
  tmpidx <- which(npchrs > maxsize)
  if(length(tmpidx) > 0)  {
    for(i in tmpidx)  {
      cbchr <- cb[cb[[1]] == paste("chr", unique.chrs[i], sep = ""), ]
      CMpos <- cbchr[cbchr[[5]] == "acen",][1,3]
      poschr <- pos[sidx[i]:eidx[i]]
      tmp <- sum(poschr <= CMpos)
      if(tmp == 0)  {
        numP <- 0
        numQ <- chrsize[i]
      }else if(tmp == chrsize[i])  {
        numP <- chrsize[i]
        numQ <- 0
      }else  {
        numP <- max(which(poschr <= CMpos))
        numQ <- chrsize[i] - numP
      }

      if((numP > 0 & numP < minsize) | (numQ > 0 & numQ < minsize))
        tmpchr <- rep(paste(unique.chrs[i], "_ms", sep = ""), chrsize[i])
      else
        tmpchr <- rep(paste(unique.chrs[i], "_", c("p", "q"), sep = ""), times = c(numP, numQ))
      chrsOutput[sidx[i]:eidx[i]] <- tmpchr
    }
  }

  chrsOutput2 <- divideChrom(chrsOutput, maxsize)
  return(chrsOutput2)
}

