`glImage` <-
function(Z, resType, threshold, lwd = 1, drawBoundaries = TRUE)  {
  plot(NA, xlim = c(0.5, nrow(Z)+0.5), ylim = c(ncol(Z)+0.5, 0.5),
       axes = FALSE, xlab = "", ylab = "", main = "", xaxs = "i", yaxs = "i")

  for(i in 1:ncol(Z))  {
    ## We do not calculate gains/losses for original data,
    ## CGHclassify, or results given by an algorithm that has thrown a
    ## non-correctable error.
    if(resType[i] == "SLR")  {
      gl <- findGNL(Z[,i], threshold = threshold)
      if(nrow(gl$gain) > 0)  {
        rect(xleft = gl$gain$Start-0.5, xright = gl$gain$End+0.5,
             ybottom = i+0.5, ytop = i-0.5, col = "orange", border = "orange")
      }
      if(nrow(gl$loss) > 0)  {
        rect(xleft = gl$loss$Start-0.5, xright = gl$loss$End+0.5,
             ybottom = i+0.5, ytop = i-0.5, col = "green", border = "green")
      }
    }else  {
      rect(xleft = 0.5, xright = nrow(Z)+0.5,
           ybottom = i+0.5, ytop = i-0.5, col = "gray")
    }
  }

  if(drawBoundaries)  {
    abline(h = 0.5+1:(ncol(Z)-1), col = "black", lwd = lwd)
    box()
  }
}

