`sm.runavg` <-
function(y, w = 5, usecompiledcode = TRUE)  {
  nbr <- round((w-1)/2)
  m <- length(y)

  if(m >= w)  {
    if(usecompiledcode)  {
      ys <- .C("runavgNA",
               window = as.integer(w),
               m = as.integer(m),
               x = as.double(y),
               xs = double(m), NAOK = TRUE)$xs
    }else  {
      ys <- numeric(length(y))

      for(i in 1:nbr)
        ys[i] <- mean(y[1:(2*i-1)], na.rm = TRUE)

      for(i in (1+nbr):(m-nbr))
        ys[i] <- mean(y[(i-nbr):(i+nbr)], na.rm = TRUE)

      for(i in (m-nbr+1):m)
        ys[i] <- mean(y[(2*i-m):m], na.rm = TRUE)
    }

    ys[is.na(y)] <- NA
    return(ys)
  }else  {
    stop("Length of y is less than specified width\n")
  }
}

