`sm.wavelet` <-
function(y, n = 3)  {
  res <- rep(NA, length(y))
  ind.nona <- which(!is.na(y))
  if(log2(length(ind.nona)) < n)  {
    cat("The number of finite values in y is fewer than allowed for the depth of decomposition.\n")
    nchange <- floor( log2(length(ind.nona)) )
    cat("Changing n from ", n, " to ", nchange, ".\n", sep = "")
    n <- nchange
  }
  wc <- modwt(y[ind.nona], wf = "haar", n.levels = n)
  res[ind.nona] <- imodwt(sure.thresh(wc, max.level = n, hard = FALSE))
  return(res)
}

