/***********************************************************************
  rowMedians.c
  Weil Lai

  This code calculates the median for each row in the input matrix
***********************************************************************/

#include <R.h>

void rowMedians(int *nr, int *nc, double *x, double *mV)
{
  int i,j;

  double *temprow;
  temprow = (double *) Calloc(*nc, double);

  if(*nc % 2 == 1) {
    for(i=0; i<*nr; i++) {
      for(j=0; j<*nc; j++)
	temprow[j] = x[i + *nr*j];

      R_rsort(temprow, *nc);
      mV[i] = temprow[*nc/2];
    }
  }else {
    for(i=0; i<*nr; i++) {
      for(j=0; j<*nc; j++)
	temprow[j] = x[i + *nr*j];

      R_rsort(temprow, *nc);
      mV[i] = 0.5*(temprow[*nc/2-1] + temprow[*nc/2]);
    }
  }

  Free(temprow);
}

void rowMediansNA(int *nr, int *nc, double *x, double *mV)
{
  int i,j,k;

  double *temprow;
  temprow = (double *) Calloc(*nc, double);

  for(i = 0; i < *nr; i++) {
    k = 0;
    for(j = 0; j < *nc; j++) {
      if(!ISNA(x[i + *nr*j])) {
	temprow[k] = x[i + *nr*j];
	k++;
      }
    }

    if(k == 0) {
      mV[i] = NA_REAL;
    }else if(k == 1) {
      mV[i] = temprow[0];
    }else if(k == 2) {
      mV[i] = 0.5*(temprow[0]+temprow[1]);
    }else {
      R_rsort(temprow, k);
      if(k % 2 == 1) {
	mV[i] = temprow[k/2];
      }else {
	mV[i] = 0.5*(temprow[k/2-1] + temprow[k/2]);
      }
    }
  }

  Free(temprow);
}
