#include <R.h>

void runavg(int *window, int *m, double *x, double *xs)
{
  int i, j, nbr;
  double temp_sum;
  nbr = round((*window-1.0)/2);

  for(i = 0; i <= nbr-1; i++) {
    temp_sum = 0.0;

    for(j = 0; j <= 2*i; j++)
      temp_sum += x[j];

    xs[i] = temp_sum / (2*i+1); 
  }
  
  for(i = nbr; i <= *m-nbr-1; i++) {
    temp_sum = 0.0;
    for(j = i-nbr; j <= i+nbr; j++)
      temp_sum += x[j];

    xs[i] = temp_sum / *window;
  }

  for(i = *m-nbr; i <= *m-1; i++) {
    temp_sum = 0.0;
    for(j = 2*i-*m+1; j <= *m-1; j++) 
      temp_sum += x[j];

    xs[i] = temp_sum / (*m*2-2*i-1);
  }     

}


void runavgNA(int *window, int *m, double *x, double *xs)
{
  int i, j, nbr, k;
  double temp_sum;
  nbr = round((*window-1.0)/2);

  for(i = 0; i <= nbr-1; i++) {
    temp_sum = 0.0;
    k = 0;
    for(j = 0; j <= 2*i; j++) {
      if(!ISNA(x[j])) {
	temp_sum += x[j];
	k++;
      }
    }

    if(k != 0)
      xs[i] = temp_sum / k; 
    else
      xs[i] = NA_REAL;
  }
  
  for(i = nbr; i <= *m-nbr-1; i++) {
    temp_sum = 0.0;
    k = 0;
    for(j = i-nbr; j <= i+nbr; j++) {
      if(!ISNA(x[j])) {
	temp_sum += x[j];
	k++;
      }
    }

    if(k != 0)
      xs[i] = temp_sum / k;
    else
      xs[i] = NA_REAL;
  }

  for(i = *m-nbr; i <= *m-1; i++) {
    temp_sum = 0.0;
    k = 0;
    for(j = 2*i-*m+1; j <= *m-1; j++) {
      if(!ISNA(x[j])) {
	temp_sum += x[j];
	k++;
      }
    }

    if(k != 0)
      xs[i] = temp_sum / k;
    else
      xs[i] = NA_REAL;
  }     

}
